<template>
  <div class="wrapper deals" style="max-width: 100%">
    <v-card :loading="loading" style="max-width: 100%; overflow: hidden">
      <v-toolbar height="60px">
        <v-spacer></v-spacer>
        <v-toolbar-items>
          <v-combobox
            v-if="1==='пока скрыть'"
            v-model="searchParam.selected"
            @keyup.enter="searchLead"
            label="Поиск"
            multiple
            persistent-hint
            small-chips
          >
            <template v-slot:no-data>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title>
                    Введите слово и нажмите <kbd>enter</kbd>, чтобы добавить параметр поиска
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </template>
          </v-combobox>
          <v-dialog
            v-model="dialog"
            width="500"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="#000000"
                v-bind="attrs"
                v-on="on"
                text
                :x-small="screenWidth < 600"
              >
                <v-icon color="#9EACC0">mdi-dots-vertical</v-icon>
                Настройки
              </v-btn>
            </template>

            <v-card class="pa-5">
              <v-card-title class="text-h5">
                Настройки
                <span style="font-size: 10px; opacity: .6;font-style: italic">Кнопка "Сохранить" сохранит ваши настройки, даже после обновления страницы</span>
              </v-card-title>
              <v-divider class="mb-5"></v-divider>
              <v-card-text>
                <v-checkbox
                  v-for="column in columns"
                  v-model="column.see"
                  :key="column.id"
                  :label="column.title"
                  :value="column.see"
                  class="ma-0 pa-0"
                  style="height: 30px"
                ></v-checkbox>
                <v-text-field placeholder="Введите количество отображаемых лидов" filled v-model="setViewsCount" class="mt-4" label="Отображать по"/>
              </v-card-text>

              <v-divider></v-divider>

              <v-card-actions>
                <v-btn
                  color="primary"
                  elevation="2"
                  raised
                  @click="setSeeColumns"
                  class="mx-auto"
                >
                  Сохранить
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog
            v-model="addLeadDialog"
            width="500"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                text
                v-bind="attrs"
                v-on="on"
                :x-small="screenWidth < 600"
              >
                Добавить сделку
                <v-icon color="#fff">mdi-plus</v-icon>
              </v-btn>
            </template>

            <v-card class="pa-5">
              <v-card-title class="text-h5">
                Новая сделка
                <span style="font-size: 10px; opacity: .6;font-style: italic">Укажите минимальную допустимую информацию о сделке</span>
              </v-card-title>
              <v-divider class="mb-5"></v-divider>
              <v-card-text>
                <v-text-field v-model="newLead.name" label="Название" solo/>
                <v-text-field v-model="newLead.email" label="Email" solo/>
                <v-text-field v-model="newLead.phone" label="Телефон" solo/>
                <v-text-field v-model="newLead.website" label="Источник" solo/>
              </v-card-text>

              <v-divider></v-divider>

              <v-card-actions>
                <v-btn
                  color="primary"
                  elevation="2"
                  raised
                  @click="addLead"
                  class="mx-auto"
                >
                  Добавить
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-btn
            text
            @click="showBasket"
            :x-small="screenWidth < 600"
          >{{isBasket && 'Все лиды' || 'Корзина'}}</v-btn>
          <v-btn
            text
            @click="initialize"
            :x-small="screenWidth < 600"
          >Обновить</v-btn>
        </v-toolbar-items>
      </v-toolbar>
      <v-container v-if="notifications">
        <v-row class="py-5" justify="center" mb="3">
          <v-col cols="6" v-for="notification in notifications" :key="notification._id">
            <v-card
              v-if="notification.see && notification.views.find(el => el.value === USER.roles[0]) > -1 || !notification.views || USER.roles[0] === 'ADMIN'"
              class="px-8 py-4 justify-center align-center text-center"
              :color="notification.background"
            >
              <div class="text-h6 mb-3" :style="{color:notification.color || '#000'}">
                <v-icon class="mr-1">mdi-information-outline</v-icon>
                {{notification.title || "Обьявление"}}
              </div>
              <div :style="{color:notification.color || '#000'}">
                {{notification.comments}}
              </div>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
      <div v-if="leads && selectedLead" :style="{opacity: !selectedLead.length && '0' || '1', pointerEvents: !selectedLead.length && 'none' || 'auto', }"  class="d-flex ml-auto justify-end align-center">
        <p class="mr-4 d-flex align-center ma-0">Выбрано: {{selectedLead.length}} шт.</p>
        <v-menu
          :close-on-content-click="false"
          :nudge-width="100"
          bot
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              small
              v-bind="attrs"
              v-on="on"
              @click.prevent="getUsers(777666)"
              class="mr-2"
            >
              {{ selectedLeadResponsible.length && selectedLeadResponsible || 'Отвественный'}}
            </v-btn>
          </template>
          <v-autocomplete
            v-model="selectedLeadResponsible"
            :filter="customFilter"
            :items="users"
            item-text="username"
            item-value="username"
            dense
            solo
            style="z-index: 211"
            autofocus
          >
            <template v-slot:selection="data">
              <span v-bind="data.attrs" @click="data.select">{{ data.item.username }}</span>
            </template>
            <template v-slot:item="data">
              <v-list-item-content @click="selectResponsible(777666, data.item._id, data.item.username)">
                <v-list-item-title v-if="data.item.username" v-html="data.item.username"></v-list-item-title>
                <v-list-item-title v-else>Не выбрано</v-list-item-title>
                <v-list-item-subtitle v-if="data.item.name.length" v-html="` (${data.item.name})(${data.item.roles[0]})`"></v-list-item-subtitle>
              </v-list-item-content>
            </template>
          </v-autocomplete>
        </v-menu>
        <v-menu
          bottom
          offset-y
          max-height="400"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              small
              v-bind="attrs"
              v-on="on"
              class="mr-2"
            >Статус</v-btn>
          </template>
          <v-list v-if="tags.length">
            <v-list-item
              v-for="(tag, i) in tags"
              :key="i"
              @click="selectStatus(777666, tag._id, i)"
            >
              <v-list-item-title style="line-height: inherit!important;">
                <v-chip
                  small
                  :style="{
                          backgroundColor: tag.color,
                          color: '#fff'
                        }"
                >{{ tag.name }}</v-chip>
              </v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
        <v-btn @click="deleteLead" small class="mr-4">Удалить</v-btn>
      </div>
      <div class="table-wrap">
        <section v-if="!searchNotFound" class="table pa-4 pb-1">
          <div class="table-wrap" style="flex-direction: column">
            <table style="padding-left: 50px">
              <tbody class="pr-8">
              <tr>
                <th
                  v-for="(column, index) in columns"
                  :key="`table-${column.id}-th`"
                  v-show="column.see"
                  @click="distinctLead(column.value, index)"
                  class="pt-3"
                >
                  <v-autocomplete
                    v-model="sortModel[column.value]"
                    :items="sortItems[column.value]"
                    :loading="sortLoading === index"
                    dense
                    :label="column.title"
                    class="column-title-autocomplete"
                    :item-text="column.value"
                    :item-value="column.value"
                    multiple
                    @keyup.enter="sorted($event, column.value)"
                  >
                    <template v-slot:selection="{ attr, on, item, selected }">
                      <v-chip
                        v-bind="attr"
                        :input-value="selected"
                        color="blue"
                        class="white--text"
                        v-on="on"
                        x-small
                      >
                        <span v-text="item"></span>
                      </v-chip>
                    </template>
                    <template v-slot:item="{ item }">
                      <v-list-item-content>
                        <v-list-item-title v-text="item || 'Не указано'">

                        </v-list-item-title>
                      </v-list-item-content>
                      <v-list-item-action>
                        <v-icon>mdi-circle-double</v-icon>
                      </v-list-item-action>
                    </template>
                  </v-autocomplete>
                </th>
              </tr>
              <tr
                v-for="(lead, index) in (isBasket && filterArr || leads)"
                :key="lead._id + index"
                v-if="(!lead.basket || isBasket) && !sortNotFound"
                :style="{opacity: (lead.name === 'TEST DEV' && isDev) && '.2', pointerEvents: (lead.name === 'TEST DEV' && isDev) && 'none'}"
              >
                <td v-if="columns[0].see">{{lead.name}}</td>
                <td v-if="columns[1].see">
                  <v-menu
                    :close-on-content-click="false"
                    :nudge-width="100"
                    bot
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        text
                        v-bind="attrs"
                        v-on="on"
                        @click.prevent="getUsers(index)"
                        small
                      >
                        <v-chip color="primary" v-if="lead.responsible.username" x-small>{{lead.responsible.username}}</v-chip>
                        <span style="color: red" v-else>Указать</span>
                      </v-btn>
                    </template>
                    <v-autocomplete
                      v-model="lead.responsible.username"
                      :filter="customFilter"
                      :items="users"
                      item-text="username"
                      item-value="username"
                      dense
                      solo
                      style="z-index: 111"
                    >
                      <template v-slot:selection="data">
                        <span v-bind="data.attrs" @click="data.select">{{ data.item.username }}</span>
                      </template>
                      <template v-slot:item="data">
                        <v-list-item-content @click="selectResponsible(index, data.item._id, data.item.username)">
                          <v-list-item-title v-if="data.item.username" v-html="data.item.username"></v-list-item-title>
                          <v-list-item-title v-else-if="USER.roles.indexOf('ADMIN') >= 0 || USER.roles.indexOf('suHOS') >= 0 || USER.roles.indexOf('HOS') >= 0">Не выбрано</v-list-item-title>
                          <v-list-item-subtitle v-if="data.item.name" v-html="` (${data.item.name})(${data.item.roles[0]})`"></v-list-item-subtitle>
                        </v-list-item-content>
                      </template>
                    </v-autocomplete>
                  </v-menu>
                </td>
                <td v-if="columns[2].see">{{lead.website}}</td>
                <td v-if="columns[3].see">
                  <a :href="`tel:${lead.phone}`">{{lead.phone}}</a><br>
                  <a :href="`mailto:${lead.email}`">{{lead.email}}</a>
                </td>
                <td v-if="columns[4].see">{{lead.city}}</td>
                <td v-if="columns[5].see">
                  <v-menu
                    bottom
                    offset-y
                    max-height="400"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-chip
                        :style="{
                            backgroundColor: lead.status && lead.status.color || 'gray',
                            color: '#fff'
                          }"
                        v-bind="attrs"
                        v-on="on"
                        small
                      >{{lead.status && lead.status.name || 'Указать'}}</v-chip>
                      <v-chip
                        v-if="lead.status_comment"
                        :style="{
                            backgroundColor: lead.status && lead.status.color || 'gray',
                            color: '#fff'
                          }"
                        x-small
                      >Причина: {{lead.status_comment}}</v-chip>
                    </template>
                    <v-list v-if="tags.length">
                      <v-list-item
                        v-for="(tag, i) in tags"
                        :key="i"
                        @click="selectStatus(lead._id, tag._id, i, tag)"
                      >
                        <v-list-item-title style="line-height: inherit!important;">
                          <v-chip
                            small
                            :style="{
                            backgroundColor: tag.color,
                            color: '#fff'
                          }"
                          >{{ tag.name }}</v-chip>
                        </v-list-item-title>
                      </v-list-item>
                    </v-list>
                  </v-menu>
                </td>
                <td v-if="columns[6].see" class="d-flex flex-column px-2">
                  <v-chip
                    v-for="(task, index) in lead.task"
                    :key="`task_key${task.task}-${index}`"
                    :class="{'white--text':task.statusTask, 'red':new Date(task.taskDate) < new Date(), 'green':new Date(task.taskDate) > new Date()}"
                    x-small
                    class="ma-1"
                    v-if="task&&task.statusTask"
                  >
                    {{task.task}} до {{`${task.taskHour} ${formatDate(task.taskDate)}`}}
                  </v-chip>
                </td>
                <td v-if="columns[7].see"><span :class="{'color-red':!lead.budget, 'blue--text':lead.budget}">{{ lead.budget || 'нет' }}</span></td>
                <td v-if="columns[8].see"><span :class="{'color-red':!lead.prepay, 'blue--text':lead.prepay}">{{ lead.prepay || 'нет' }}</span></td>
                <td v-if="columns[9].see"><span :class="{'color-red':!lead.debt, 'blue--text':lead.debt}">{{ lead.debt || 'нет' }}</span></td>
                <td v-if="columns[10].see">{{formatDate(lead.updatedAt, true)}}</td>
                <td v-if="columns[11].see">{{formatDate(lead.createdAt, true)}}</td>
                <td>
                  <router-link :to="{name: 'Lead', params: {id: lead._id}}">
                    <img src="../assets/img/general/show.svg" alt="" title="Просмотр">
                  </router-link>
                  <img v-if="USER.roles.indexOf('ADMIN') >= 0 && isBasket" @click="reestablishLead(lead._id, index)" src="../assets/img/icons/reestablish.png" alt="" title="Восстановить">
                  <img v-if="USER.roles.indexOf('ADMIN') >= 0 && 1 === 2" @click="deleteLead(lead._id, index)" src="../assets/img/general/urn.svg" alt="" title="Удалить">
                  <input v-if="USER.roles.indexOf('ADMIN') >= 0 && !isBasket" type="checkbox" v-model="selectedLead" :value="lead">
                </td>
              </tr>
              </tbody>
            </table>
            <v-card v-if="sortNotFound" class="py-6 mx-10 d-flex justify-center">
              <v-card-title>Ничего не найдено</v-card-title>
            </v-card>
            <v-progress-linear v-if="!leads.length" indeterminate color="primary"></v-progress-linear>
          </div>
        </section>
        <div v-if="!sortNotFound && !searchNotFound" style="width: 100%; align-items: center">
          <v-btn v-if="leads.length" @click="moreLeads" color="primary" width="100%" class="mx-auto py-4">Загрузить еше</v-btn>
        </div>
      </div>
      <v-card v-if="searchNotFound" class="py-6 mx-10 d-flex justify-center">
        <v-card-title>Ничего не найдено</v-card-title>
      </v-card>
    </v-card>
    <v-dialog v-model="prichinaOtkaza.dialog">
      <v-card>
        <v-card-title>Укажите причину отказа</v-card-title>
        <v-text-field v-model="prichinaOtkaza.commit"></v-text-field>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import api from '@/API/api'
import formatDate from "./utils/formatDate";
import {mapGetters} from 'vuex'
import Schedule from '@/components/Schedule'

export default {
  name: 'Deals',
  components: {
    Schedule,
  },
  data () {
    return {
      screenWidth: 0,
      interval1: '',
      interval2: '',
      sortItems: {
        name: [],
        responsible: [],
        website: [],
        phone: [],
        city: [],
        status: [],
        task: [],
        budget: [],
        prepay: [],
        debt: [],
        updatedAt: [],
        createdAt: [],
      },
      sortNotFound: false,
      sortLoading: null,
      sortModel: {
        name: [],
        responsible: [],
        website: [],
        phone: [],
        city: [],
        status: [],
        task: [],
        budget: [],
        prepay: [],
        debt: [],
        updatedAt: [],
        createdAt: [],
      },
      newLead: {
        name: '',
        phone: '',
        email: '',
        website: ''
      },
      queryText: '',
      timeout: null,
      leads: [],
      filterLeads: [],
      showUser: false,
      notifications: [],
      tags: [],
      dialog: false,
      addLeadDialog: false,
      dialogLeads: false,
      select: false,
      columns: [],
      setViewsCount: null,
      tabs: [
        { title: 'Удалить', id: 1 },
        { title: 'Сменить отвественного', id: 2 },
        { title: 'Сменить статус', id: 3 },
        { title: 'Выгрузить .xls', id: 4 }
      ],
      selectedLead: [],
      selectedLeadResponsible: {},
      activeTab: 1,
      selected: ['element'], // чекбокс в окне "колонки"
      page: 1,
      users: [],
      limit: 0,
      loading: false,
      isBasket: false,
      filterArr: [],
      searchParam: {
        selected: [],
        queryText: [],
        parameters: [
          {}
        ],
      },
      prichinaOtkaza: {
        dialog: false,
        commit: ''
      },
      searchNotFound: false
    }
  },
  async created () {
    await this.initialize()
  },
  watch: {
    'sortModel': {
      deep: true,
      handler(val) {
        console.log(val)
        // проверяю все поля поиска на пустоту
        let flag = false
        for(let prop in val){
          if(val.hasOwnProperty(prop) && val[prop].length !== 0){
            console.log(`${prop} not empty`)
            flag = true
            this.sort()
            break
          }
        }
        // если ничего нет, то получаем лиды getLeads()
        !flag && this.getLeads()
      }
    },
    ['searchParam.selected'] (val) {
      if (!val.length) {
        this.getLeads()
        this.interval2 = setInterval(() => this.checkNewLead(), 15000);
      }
    }
  },
  mounted () {
    this.interval1 = setInterval(() => this.checkNewLead(), 15000); // сохраняем идентификатор интервала
    this.screenWidth = window.innerWidth;
    window.addEventListener('resize', this.handleResize);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.handleResize);
    clearInterval(this.interval1)
    clearInterval(this.interval2)
  },
  computed: {
    ...mapGetters(["USER"]),
    search: {
      get() {
        return this.queryText
      },
      set(val) {
        if (this.timeout) clearTimeout(this.timeout)
        this.timeout = setTimeout(() => {
          if (val !== null && val.length > 2) this.searchLead(val)
          else return false
        }, 1000)
        if (val === null) this.getLeads()
      },
    },
    isDev: function () {
      // чтобы не удаляли тестовые лиды для разработки
      return window.location.hostname !== 'localhost'
    }
  },
  methods: {
    formatDate,
    async distinctLead (el, index) {
      this.sortLoading = index
      api.distinctLead({value: el}).then(res => {
        this.sortItems[el].push('')
        this.sortItems[el].push(...res.data.value)
        // добавим поле отказы, чтобы их можно было глянуть, так как они скрыты по умолчанию
        this.sortItems.status.push('Отказ')
        this.sortLoading = null
      })
    },
    async sort (limit=null) {
      clearInterval(this.interval1)
      clearInterval(this.interval2)
      setTimeout(() => {
        this.loading = true
        api.sortLead({sort: this.sortModel, limit: limit || this.limit}).then(res => {
          if(!res.data.leads.length) {
            this.sortNotFound = true
          } else {
            this.leads = res.data.leads
            this.sortNotFound = false
            this.loading = false
          }
        })
      }, 100)
    },
    async sorted (val, el) {
      clearInterval(this.interval1)
      clearInterval(this.interval2)
      if(el === 'phone' || el === 'name') {
        const obj = Object.entries(this.sortModel)
        for (const [key] of obj) {
          key === el && (this.sortModel[key] = [val.target.value])
        }
      } else return true
    },
    async searchLead (val) {
      this.loading = true
      val = this.searchParam.selected
      await api.searchLead({ val: val }).then(res => {
        if (res.data.status) {
          if (res.data.lead.length) this.leads = res.data.lead
          else this.searchNotFound = true
        }
        this.loading = false
      })
    },
    initialize() {
      this.setViewsCount = +(localStorage.setViewsCount && localStorage.getItem('setViewsCount') || localStorage.setItem('setViewsCount', 10))
      if (localStorage.columns) {
        const columns = localStorage.getItem('columns')
        this.columns = JSON.parse(columns)
      } else this.columns = [
        { title: 'Название', value: "name", see: true, id: 1 },
        { title: 'Ответственный', value: "responsible", see: true, id: 2 },
        { title: 'Сайт', value: "website", see: true, id: 3 },
        { title: 'Клиент', value: "phone", see: true, id: 4 },
        { title: 'Город', value: "city", see: true, id: 5 },
        { title: 'Статус', value: "status", see: true, id: 6 },
        { title: 'Задача', value: "task", see: true, id: 7 },
        { title: 'Бюджет', value: "budget", see: true, id: 8 },
        { title: 'Предоплата', value: "prepay", see: true, id: 9 },
        { title: 'Долг', value: "debt", see: true, id: 10 },
        { title: 'Изменен', value: "updatedAt", see: true, id: 11 },
        { title: 'Создан', value: "createdAt", see: true, id: 12 },
      ]
      this.getLeads()
      this.getLeadInfo()
    },
    async addLead () {
      if (this.USER.roles.indexOf('ADMIN') < 0) {
        await api.addLead({
          name: this.newLead.name,
          email: this.newLead.email,
          phone: this.newLead.phone,
          website: this.newLead.website,
          responsible: {
            username: this.USER.username,
            _id: this.USER._id
          },
        }).then(res => {
          if (res.data.status) this.initialize()
          if (res.data.status) this.addLeadDialog = false
        })
      }
      else await api.addLead({
        name: this.newLead.name,
        email: this.newLead.email,
        phone: this.newLead.phone,
        website: this.newLead.website
      }).then(res => {
        if (res.data.status) this.initialize()
        if (res.data.status) this.addLeadDialog = false
      })
    },
    customFilter (item, queryText, itemText) {
      const textOne = item.username.toLowerCase()
      const textTwo = item.name.toLowerCase()
      const searchText = queryText.toLowerCase()

      return textOne.indexOf(searchText) > -1 ||
        textTwo.indexOf(searchText) > -1
    },
    remove (item) {
      const index = this.leads.indexOf(item.username)
      if (index >= 0) this.leads.splice(index, 1)
    },
    setSeeColumns() {
      localStorage.setItem('columns', JSON.stringify(this.columns))
      localStorage.setItem('setViewsCount', JSON.stringify(+(this.setViewsCount)))
      this.dialog = false
    },
    async selectResponsible(indexLead, user_id, username) {
      if (indexLead === 777666) {
        this.selectedLead.forEach(el => {
          el.responsible = {_id: user_id, username}
          api.selectResponsibleLead({lead_id: el._id, user_id, username}).then(res => res.data.status && (this.menuResponsible = false))
        })
      } else {
        const lead_id = this.leads[indexLead]._id
        await api.selectResponsibleLead({lead_id, user_id, username}).then(res => res.data.status && (this.menuResponsible = false))
      }
    },
    async selectStatus(leadId, statusId, index, status = '') {
      if (leadId === 777666) {
        if (status.name === 'Отказ') {
          const comment = prompt('Пожалуйста, укажите комментарий отказа');
          this.selectedLead.forEach(el => {
            api.selectStatusLead({leadId: el._id, statusId, comment})
                .then(res => res.data.status && (this.selectedLead = []))
            this.getLeads()
          })
        }
        else {
          this.selectedLead.forEach(el => {
            if (!el.responsible.username) {
              api.selectResponsibleLead({lead_id: el._id, user_id: this.USER._id, username: this.USER.username})
            }
            api.selectStatusLead({leadId: el._id, statusId})
                .then(res => {
                  if (res.data.status) {
                    this.selectedLead = []
                  }
                })
            this.getLeads()
          })
        }
      } else {
        if (status.name === 'Отказ') {
          const comment = prompt('Пожалуйста, укажите комментарий отказа');
          await api.selectStatusLead({leadId, statusId, comment}).then(res => {
            if (res.data.status) {
              this.leads.map(el => {
                if (el._id === leadId) el.status = this.tags[index]
              })
            }
          })
        }
        else {
          const lead = this.leads.find(lead => lead._id === leadId)
          if (!lead.responsible.username) {
            api.selectResponsibleLead({lead_id: leadId, user_id: this.USER._id, username: this.USER.username})
          }
          await api.selectStatusLead({
            leadId,
            statusId
          }).then(res => {
            if (res.data.status) {
              this.leads.map(el => {
                if (el._id === leadId) el.status = this.tags[index]
              })
            }
          })
          await this.getLeads()
        }
      }
    },
    async moreLeads() {
      this.limit += this.limit
      if (Object.values(this.sortModel).some((arr) => arr.length > 0)) await this.sort()
      else await api.getLeads({limit: this.limit}).then(res => (this.leads = res.data.leads))
    },
    async getLeads() {
      this.loading = true
      this.searchNotFound = false
      this.limit = this.limit > this.setViewsCount && this.limit || this.setViewsCount
      await api.getLeads({limit: this.limit}).then(res => {
        this.leads = res.data.leads.filter(el => {
          return !el.basket && el
        })
      }).catch(res => {
        if (!res.response.data.status) this.$router.push({name: 'Auth'})
      })
      await api.getBasket({limit: this.limit}).then(res => {
        this.filterArr = res.data.basket
      })
      this.loading = false
      await api.getStatusLead().then(res => (this.tags = res.data.statusLeads))

      this.loading = false
    },
    async getUsers(index) {
      this.menuResponsible = index
      if (!this.users.length) await api.getUsers().then(res => {
        if(res.data.status) {
          this.users = res.data.users
          const myArr = {
            username: this.USER.username,
            _id: this.USER._id,
            name: this.USER.name,
            roles: this.USER.roles
          }
          if (this.USER.roles.indexOf('ADMIN') >= 0 || this.USER.roles.indexOf('suHOS') >= 0 || this.USER.roles.indexOf('HOS') >= 0) {
            this.users.unshift({
              username: '',
              _id: '',
              name: '',
              roles: ['']
            },{
              username: this.USER.username,
              _id: this.USER._id,
              name: this.USER.name,
              roles: this.USER.roles
            })
          } else this.users.push(myArr)
        }
      })
      else return false
    },
    async getLeadInfo() {
      await api.getLeadInfo().then(res => res.data.status && (this.notifications = res.data.leadInfo))
    },
    async reestablishLead (_id, index) {
      await api.toBasketLead({_id: _id})
        .then(res => {
          this.getLeads()
          this.leads.push(this.filterArr[index])
          this.filterArr.splice(index,1).push(this.leads[index])
        })
    },
    async deleteLead(_id, index) {
      if (!this.isBasket) {
        this.selectedLead.forEach((el) => {
          api.toBasketLead({_id: el._id})
            .then(res => {
              this.leads.forEach((elem,i) => {
                if (elem._id === el._id) {
                  this.filterArr.push(this.leads[i])
                  this.leads.splice(i,1)
                } else return false
              })
            })
        })
        this.selectedLead = []
      } else {
        await api.deleteLead({_id: _id})
          .then(res => {
            this.filterArr.splice(index,1)
          })
      }
    },
    async showBasket () {
      this.isBasket = !this.isBasket
      if (!this.filterArr.length) {
        this.loading = true
        await api.getBasket({limit: this.limit}).then(res => {
          this.filterArr = res.data.basket
          this.loading = false
        })
      }
    },
    handleResize() {
      this.screenWidth = window.innerWidth;
    },
    async checkNewLead () {
      this.loading = true
      this.searchNotFound = false
      await api.getLeads({limit: this.limit}).then(async res => {
        const arr1 = this.leads
        const arr2 = res.data.leads
        const arr1Str = JSON.stringify(arr1);
        const arr2Str = JSON.stringify(arr2);
        if (arr1Str === arr2Str) {
          this.loading = false
        } else {
          await this.getLeads()
          this.loading = false
        }
      })

    }
  }
}
</script>

<style lang="scss" scoped>
.v-input__slot {
  padding: 0;
}
.wrapper {
  display: grid;
  padding-right: 0px !important;
  padding-left: 0px !important;
}
.deals {
  display: grid;
  height: 100%;
  max-height: 100%;
  max-width: 100%;
  overflow: hidden;
  .table-wrap {
    max-height: calc(100vh - 280px);
    max-width: 100%;
  }
  .table {
    max-height: calc(100vh - 300px);
  }
}
.search-head {
  img {
    opacity: 0;
  }
  &:hover {
    img {
      opacity: 1;
      cursor: pointer;
    }
  }
}
  .deals-title {
    display: flex;
    align-items: center;
  }
  .deal-footer {
    display: flex;
    align-items: center;
    background: #324661;
    box-shadow: 0px 8px 20px rgba(0, 0, 0, 0.16);
    border-radius: 12px;
    padding: 12px 0;
    color: #FFFFFF;
    .col {
      text-align: center;
    }
  }
  .deal-footer-tabs {
    display: block;
    @media (max-width: 900px) {
      display: none;
    }
  }
  .mobile-tabs {
    display: none;
    @media (max-width: 900px) {
      display: block;
    }
    .deals-tab {
      display: none;
      @media (max-width: 900px) {
        display: block;
      }
    }
  }

</style>
